local OresMoney = CreateFrame("Frame")
OresMoney:RegisterEvent("BAG_UPDATE")

Auctionator.API.InternalVerifyID("Hywolf")
-- HERBS
local prixRisingGlory, prixMarrowroot, prixVigilsTorch, prixWidowbloom, prixDeathBlossom, prixNightshade = 0
local prixTotalOr, prixTotalRisingGlory, prixTotalMarrowroot, prixTotalVigilsTorch, prixTotalWidowbloom, prixTotalDeathBlossom, prixTotalNightshade = 0
local countRisingGlory, countMarrowroot, countVigilsTorch, countWidowbloom, countDeathBlossom, countNightshade = 0
-- ORES
local prixLaestrite, prixOxxein, prixPhaedrum, prixSinvyr, prixSolenium, prixElethium, prixPorousStone = 0
local prixTotalOr, prixTotalLaestrite, prixTotalOxxein, prixTotalPhaedrum, prixTotalSinvyr, prixTotalSolenium, prixTotalElethium, prixTotalPorousStone = 0
local countLaestrite, countOxxein, countPhaedrum, countSinvyr, countSolenium, countElethium, countPorousStone = 0

local plusBank = false
local details = false
local prefix = "|cFF8075BAOhm:|r"

local UIOHMoney

-- ID ITEM
local nameRisingGlory = GetItemInfo(168586)
local nameMarrowroot = GetItemInfo(168589)
local nameVigilsTorch = GetItemInfo(170554)
local nameWidowbloom = GetItemInfo(168583)
local nameDeathBlossom = GetItemInfo(169701)
local nameNightshade = GetItemInfo(171315)
local nameLaestrite = GetItemInfo(171828)
local nameOxxein = GetItemInfo(171830)
local namePhaedrum = GetItemInfo(171831)
local nameSinvyr = GetItemInfo(171832)
local nameSolenium = GetItemInfo(171829)
local nameElethium = GetItemInfo(171833)
local namePorousStone = GetItemInfo(171840)

-- Message d'accueil
print(prefix, "Type |cFF8075BA/ohm |rto show your ores/herbs value.")
print(prefix, "Scan AH with Auctionator and /reload if errors.")


-- Arrondi
local function round(n)
    return math.floor(n + 0.5)
end

-- Calcul la valeur des minerais possédés
local function moneyCount()
    -- On compte les herbes et minerais
    countRisingGlory = GetItemCount(168586)
    countMarrowroot = GetItemCount(168589)
    countVigilsTorch = GetItemCount(170554)
    countWidowbloom = GetItemCount(168583)
    countDeathBlossom = GetItemCount(169701)
    countNightshade = GetItemCount(171315)

    countLaestrite = GetItemCount(171828)
    countOxxein = GetItemCount(171830)
    countPhaedrum = GetItemCount(171831)
    countSinvyr = GetItemCount(171832)
    countSolenium = GetItemCount(171829)
    countElethium = GetItemCount(171833)
    countPorousStone = GetItemCount(171840)
    -- On récupère les prix unités depuis Auctionator
    prixRisingGlory = Auctionator.API.v1.GetAuctionPriceByItemID("Hywolf", 168586) / 10000
    prixMarrowroot = Auctionator.API.v1.GetAuctionPriceByItemID("Hywolf", 168589) / 10000
    prixVigilsTorch = Auctionator.API.v1.GetAuctionPriceByItemID("Hywolf", 170554) / 10000
    prixWidowbloom = Auctionator.API.v1.GetAuctionPriceByItemID("Hywolf", 168583) / 10000
    prixDeathBlossom = Auctionator.API.v1.GetAuctionPriceByItemID("Hywolf", 169701) / 10000
    prixNightshade = Auctionator.API.v1.GetAuctionPriceByItemID("Hywolf", 171315) / 10000

    prixLaestrite = Auctionator.API.v1.GetAuctionPriceByItemID("Hywolf", 171828) / 10000
    prixOxxein = Auctionator.API.v1.GetAuctionPriceByItemID("Hywolf", 171830) / 10000
    prixPhaedrum = Auctionator.API.v1.GetAuctionPriceByItemID("Hywolf", 171831) / 10000
    prixSinvyr = Auctionator.API.v1.GetAuctionPriceByItemID("Hywolf", 171832) / 10000
    prixSolenium = Auctionator.API.v1.GetAuctionPriceByItemID("Hywolf", 171829) / 10000
    prixElethium = Auctionator.API.v1.GetAuctionPriceByItemID("Hywolf", 171833) / 10000
    prixPorousStone = Auctionator.API.v1.GetAuctionPriceByItemID("Hywolf", 171840) / 10000
    -- On calcul le prix de chaque lot de minerai
    prixTotalRisingGlory = countRisingGlory * prixRisingGlory
    prixTotalMarrowroot = countMarrowroot * prixMarrowroot
    prixTotalVigilsTorch = countVigilsTorch * prixVigilsTorch
    prixTotalWidowbloom = countWidowbloom * prixWidowbloom
    prixTotalDeathBlossom = countDeathBlossom * prixDeathBlossom
    prixTotalNightshade = countNightshade * prixNightshade
    
    prixTotalLaestrite = countLaestrite * prixLaestrite
    prixTotalOxxein = countOxxein * prixOxxein
    prixTotalPhaedrum = countPhaedrum * prixPhaedrum
    prixTotalSinvyr = countSinvyr * prixSinvyr
    prixTotalSolenium = countSolenium * prixSolenium
    prixTotalElethium = countElethium * prixElethium
    prixTotalPorousStone = countPorousStone * prixPorousStone
    -- On calcul le prix total
    local prixTotal = prixTotalRisingGlory + prixTotalMarrowroot + prixTotalVigilsTorch + prixTotalWidowbloom + prixTotalDeathBlossom + prixTotalNightshade + prixTotalLaestrite + prixTotalOxxein + prixTotalPhaedrum + prixTotalSinvyr + prixTotalSolenium + prixTotalElethium + prixTotalPorousStone
    prixTotalOr = round(prixTotal)
    -- On affiche le prix dans le tchat
    -- print(prefix, "Ore/herb value: |cFFF0CB1E", GetCoinTextureString(prixTotalOr*10000))
end

local function refreshOHMoney()
    moneyCount()
    -- Si UI ouvert
    if UIOHMoney ~= nil then
        -- SI DETAILS, colonne 2 = Quantityn sinon = Total price
        if details then
            UIOHMoney:SetSize(450, 300);
        else
            UIOHMoney:SetSize(300, 300);
        end
        
        if details then
            UIOHMoney.panelTwo:SetText('<html><body>'..
            '<p>|cFF8075BAQuantity|r</p>'..
            '<p><br /></p>'..
            '<p>'..countRisingGlory..'</p>'..
            '<p>'..countMarrowroot..'</p>'..
            '<p>'..countVigilsTorch..'</p>'..
            '<p>'..countWidowbloom..'</p>'..
            '<p>'..countDeathBlossom..'</p>'..
            '<p>'..countNightshade..'</p>'..
            '<p><br /></p>'..
            '<p>'..countLaestrite..'</p>'..
            '<p>'..countOxxein..'</p>'..
            '<p>'..countPhaedrum..'</p>'..
            '<p>'..countSinvyr..'</p>'..
            '<p>'..countSolenium..'</p>'..
            '<p>'..countElethium..'</p>'..
            '<p>'..countPorousStone..'</p>'..
            '</body></html>');
        else
            UIOHMoney.panelTwo:SetText('<html><body>'..
            '<p>|cFF8075BATotal price|r</p>'..
            '<p><br /></p>'..
            '<p>'..GetCoinTextureString(prixTotalRisingGlory*10000, 10)..'</p>'..
            '<p>'..GetCoinTextureString(prixTotalMarrowroot*10000, 10)..'</p>'..
            '<p>'..GetCoinTextureString(prixTotalVigilsTorch*10000, 10)..'</p>'..
            '<p>'..GetCoinTextureString(prixTotalWidowbloom*10000, 10)..'</p>'..
            '<p>'..GetCoinTextureString(prixTotalDeathBlossom*10000, 10)..'</p>'..
            '<p>'..GetCoinTextureString(prixTotalNightshade*10000, 10)..'</p>'..
            '<p><br /></p>'..
            '<p>'..GetCoinTextureString(prixTotalLaestrite*10000, 10)..'</p>'..
            '<p>'..GetCoinTextureString(prixTotalOxxein*10000, 10)..'</p>'..
            '<p>'..GetCoinTextureString(prixTotalPhaedrum*10000, 10)..'</p>'..
            '<p>'..GetCoinTextureString(prixTotalSinvyr*10000, 10)..'</p>'..
            '<p>'..GetCoinTextureString(prixTotalSolenium*10000, 10)..'</p>'..
            '<p>'..GetCoinTextureString(prixTotalElethium*10000, 10)..'</p>'..
            '<p>'..GetCoinTextureString(prixTotalPorousStone*10000, 10)..'</p>'..
            '<p><br /></p>'..
            '<p>|cFF00EE66'..GetCoinTextureString(prixTotalOr*10000, 10)..'|r</p>'..
            '</body></html>');
        end

        -- SI DETAILS, on affiche colonne 3 et 4
        if details then
            UIOHMoney.panelThree:SetText('<html><body>'..
            '<p>|cFF8075BAUnit price|r</p>'..
            '<p><br /></p>'..
            '<p>'..GetCoinTextureString(prixRisingGlory*10000, 10)..'</p>'..
            '<p>'..GetCoinTextureString(prixMarrowroot*10000, 10)..'</p>'..
            '<p>'..GetCoinTextureString(prixVigilsTorch*10000, 10)..'</p>'..
            '<p>'..GetCoinTextureString(prixWidowbloom*10000, 10)..'</p>'..
            '<p>'..GetCoinTextureString(prixDeathBlossom*10000, 10)..'</p>'..
            '<p>'..GetCoinTextureString(prixNightshade*10000, 10)..'</p>'..
            '<p><br /></p>'..
            '<p>'..GetCoinTextureString(prixLaestrite*10000, 10)..'</p>'..
            '<p>'..GetCoinTextureString(prixOxxein*10000, 10)..'</p>'..
            '<p>'..GetCoinTextureString(prixPhaedrum*10000, 10)..'</p>'..
            '<p>'..GetCoinTextureString(prixSinvyr*10000, 10)..'</p>'..
            '<p>'..GetCoinTextureString(prixSolenium*10000, 10)..'</p>'..
            '<p>'..GetCoinTextureString(prixElethium*10000, 10)..'</p>'..
            '<p>'..GetCoinTextureString(prixPorousStone*10000, 10)..'</p>'..
            '</body></html>');
            
            UIOHMoney.panelFour:SetText('<html><body>'..
            '<p>|cFF8075BATotal price|r</p>'..
            '<p><br /></p>'..
            '<p>'..GetCoinTextureString(prixTotalRisingGlory*10000, 10)..'</p>'..
            '<p>'..GetCoinTextureString(prixTotalMarrowroot*10000, 10)..'</p>'..
            '<p>'..GetCoinTextureString(prixTotalVigilsTorch*10000, 10)..'</p>'..
            '<p>'..GetCoinTextureString(prixTotalWidowbloom*10000, 10)..'</p>'..
            '<p>'..GetCoinTextureString(prixTotalDeathBlossom*10000, 10)..'</p>'..
            '<p>'..GetCoinTextureString(prixTotalNightshade*10000, 10)..'</p>'..
            '<p><br /></p>'..
            '<p>'..GetCoinTextureString(prixTotalLaestrite*10000, 10)..'</p>'..
            '<p>'..GetCoinTextureString(prixTotalOxxein*10000, 10)..'</p>'..
            '<p>'..GetCoinTextureString(prixTotalPhaedrum*10000, 10)..'</p>'..
            '<p>'..GetCoinTextureString(prixTotalSinvyr*10000, 10)..'</p>'..
            '<p>'..GetCoinTextureString(prixTotalSolenium*10000, 10)..'</p>'..
            '<p>'..GetCoinTextureString(prixTotalElethium*10000, 10)..'</p>'..
            '<p>'..GetCoinTextureString(prixTotalPorousStone*10000, 10)..'</p>'..
            '<p><br /></p>'..
            '<p>|cFF00EE66'..GetCoinTextureString(prixTotalOr*10000, 10)..'|r</p>'..
            '</body></html>');
        else
            UIOHMoney.panelThree:SetText('')
            UIOHMoney.panelFour:SetText('')
        end
    
        
    end
end

-- Lorsque qu'un item est ramassé...
OresMoney:SetScript("OnEvent",
function(self, event, ...)    
    local arg1, arg2 = ...

    refreshOHMoney();
    -- On detecte si un minerai. Si oui on lance
    -- if arg2 == 3613630 or arg2 == 3480675 or arg2 == 3387974 or arg2 == 3610996 or arg2 == 3502461 or arg2 == 3692438 or arg2 == 3594132 or arg2 == 3608331 or arg2 == 3537032 or arg2 == 3616941 or arg2 == 3731242 or arg2 == 3749971 then
    -- end
    
end)

local function openUIOHMoney()
    plusBank = false
    details = false
    UIOHMoney = CreateFrame("Frame", "OHM_UIOHMoney", UIParent, "BasicFrameTemplateWithInset");
    UIOHMoney:SetSize(1000, 300);
    UIOHMoney:SetMovable(true)
    UIOHMoney:EnableMouse(true)
    UIOHMoney:RegisterForDrag("LeftButton")
    UIOHMoney:SetScript("OnDragStart", UIOHMoney.StartMoving)
    UIOHMoney:SetScript("OnDragStop", UIOHMoney.StopMovingOrSizing)
    UIOHMoney:SetPoint("CENTER"); -- Doesn't need to be ("CENTER", UIParent, "CENTER")

    UIOHMoney.title = UIOHMoney:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
    UIOHMoney.title:SetPoint("LEFT", UIOHMoney.TitleBg, "LEFT", 5, 0);
    UIOHMoney.title:SetText(prefix.." Value of your ores/herbs");

    -- Panel Left:
    UIOHMoney.panelOne = CreateFrame("SimpleHTML", nil, UIOHMoney);
    UIOHMoney.panelOne:SetFont("Fonts\\FRIZQT__.ttf", 12, "OUTLINE");
    UIOHMoney.panelOne:SetPoint("TOPLEFT", UIOHMoney, "TOPLEFT", 15, -35);
    UIOHMoney.panelOne:SetSize(180, 180);
    UIOHMoney.panelOne:SetText('<html><body>'..
        '<p><br /></p>'..
        '<p><br /></p>'..
        '<p>'..nameRisingGlory..'</p>'..
        '<p>'..nameMarrowroot..'</p>'..
        '<p>'..nameVigilsTorch..'</p>'..
        '<p>'..nameWidowbloom..'</p>'..
        '<p>'..nameDeathBlossom..'</p>'..
        '<p>'..nameNightshade..'</p>'..
        '<p><br /></p>'..
        '<p>'..nameLaestrite..'</p>'..
        '<p>'..nameOxxein..'</p>'..
        '<p>'..namePhaedrum..'</p>'..
        '<p>'..nameSinvyr..'</p>'..
        '<p>'..nameSolenium..'</p>'..
        '<p>'..nameElethium..'</p>'..
        '<p>'..namePorousStone..'</p>'..
        '<p><br /></p>'..
        '<p>|cFF00EE66TOTAL VALUE|r</p>'..
        '</body></html>');

    -- Panel Two:
    UIOHMoney.panelTwo = CreateFrame("SimpleHTML", nil, UIOHMoney);
    UIOHMoney.panelTwo:SetFont("Fonts\\FRIZQT__.ttf", 12, "OUTLINE");
    UIOHMoney.panelTwo:SetPoint("LEFT", UIOHMoney.panelOne, "LEFT", 170, 0);
    UIOHMoney.panelTwo:SetSize(140, 180);

    -- Panel Three:
    UIOHMoney.panelThree = CreateFrame("SimpleHTML", nil, UIOHMoney);
    UIOHMoney.panelThree:SetFont("Fonts\\FRIZQT__.ttf", 12, "OUTLINE");
    UIOHMoney.panelThree:SetPoint("LEFT", UIOHMoney.panelTwo, "LEFT", 75, 0);
    UIOHMoney.panelThree:SetSize(140, 180);

    -- Panel Four:
    UIOHMoney.panelFour = CreateFrame("SimpleHTML", nil, UIOHMoney);
    UIOHMoney.panelFour:SetFont("Fonts\\FRIZQT__.ttf", 12, "OUTLINE");
    UIOHMoney.panelFour:SetPoint("LEFT", UIOHMoney.panelThree, "LEFT", 100, 0);
    UIOHMoney.panelFour:SetSize(140, 180);
    refreshOHMoney();

    -- Check Button bank:
    UIOHMoney.checkBtn1 = CreateFrame("CheckButton", nil, UIOHMoney, "UICheckButtonTemplate");
    UIOHMoney.checkBtn1:SetPoint("BOTTOMLEFT", UIOHMoney, "BOTTOMLEFT", 10, 10);
    UIOHMoney.checkBtn1.text:SetText("+ bank");
    UIOHMoney.checkBtn1.tooltip = "Bank ores/herbs included";
    UIOHMoney.checkBtn1:SetScript("OnClick", 
    function()
        if plusBank then
            plusBank = false
            refreshOHMoney()
        else
            plusBank = true
            refreshOHMoney()
        end
    end
    );

    -- Check Button details:
    UIOHMoney.checkBtn2 = CreateFrame("CheckButton", nil, UIOHMoney, "UICheckButtonTemplate");
    UIOHMoney.checkBtn2:SetPoint("LEFT", UIOHMoney.checkBtn1, "LEFT", 80, 0);
    UIOHMoney.checkBtn2.text:SetText("Details");
    UIOHMoney.checkBtn2:SetScript("OnClick", 
    function()
        if details then
            details = false
            refreshOHMoney()
        else
            details = true
            refreshOHMoney()
        end
    end
    );
end

-- Commande /ohm pour lancer la fonction
SLASH_ohm1 = "/ohm"
SlashCmdList ["ohm"] = function ( msg )
    if msg == "" then
        moneyCount()
        openUIOHMoney()
    elseif msg == "1" then
        moneyCount()
    else
    end
end